from PyQt5 import QtWidgets

from ArtNet.gui.dialogs.link_input_dialog.link_input_dialog import Ui_Dialog


class LinkInputDialog(QtWidgets.QDialog):

    def __init__(self, parent=None, link: str = None):
        super().__init__(parent)
        self.ui = Ui_Dialog()
        self.ui.setupUi(self)

        if link is not None:
            self.ui.link_line.setText(link)

    def get_link_text(self) -> str:
        return self.ui.link_line.text()

    def exec_(self) -> str:
        if super(LinkInputDialog, self).exec_() == QtWidgets.QDialog.Rejected:
            return None
        return self.get_link_text()

